#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <time.h>

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS0"
#define FALSE 0
#define TRUE 1
int startdome=0;
int stop_dome=0;

int wait_flag=TRUE;                /* TRUE while no signal received */
void signal_handler_IO (int status) { wait_flag = FALSE; }

FILE *fp;
unsigned char bou[255],  bin[255], bb[255];

struct tm *t;
time_t it;
char jtime[10]={0,0,':',0,0,':',0,0,'_',0};
char ss[3]={0,0,0},pp[3],mm[3]={0,32,0};
int expt=0;
float rect=0.;
int obsnum=-1;
int restime=0;
char b80[80];
int ontime=0;                    // 17:00-30:59 record down bjt,ra,de

getime()
{
  int i;
  char dummy[25];
  it=time(0);
  t=localtime(&it);
  strcpy(dummy,asctime(t));
  for(i=0;i<8;i++)jtime[i]=dummy[11+i];
}

main(int ac)
{
  int i,k,itc=3;
  int job=0, oldjob=0,wave,vv;
  int fd,c, res;
  char exps[67];
  float tems;
  struct termios oldtio,newtio;
  struct sigaction saio;           /* definition of signal action */
  system("sudo chmod 777 /dev/ttyS0");

  printf("\n\tuni                  (normal)");
  printf("\n\tuni 1                (not send move,filt command)");
  printf("\n\tuni 1  1             (not send all)\n\n");

  /* open the device to be non-blocking (read will return immediatly) */
//  fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK);
  fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK | O_NDELAY);
  if (fd <0) {perror(MODEMDEVICE); return(-1); }

  /* install the signal handler before making the device asynchronous */
  saio.sa_handler = signal_handler_IO;
//  saio.sa_mask = 0;
  saio.sa_flags = 0;
  saio.sa_restorer = NULL;
  sigaction(SIGIO,&saio,NULL);

  /* allow the process to receive SIGIO */
  fcntl(fd, F_SETOWN, getpid());
  /* Make the file descriptor asynchronous (the manual page says only
       O_APPEND and O_NONBLOCK, will work with F_SETFL...) */
  fcntl(fd, F_SETFL, FASYNC);

  tcgetattr(fd,&oldtio); /* save current port settings */
  /* set new port settings for canonical input processing */
//  newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
  newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
  newtio.c_iflag = IGNPAR | ICRNL;
  newtio.c_oflag = 0;
  newtio.c_lflag = ICANON;
  newtio.c_cc[VMIN]=1;
  newtio.c_cc[VTIME]=0;
  tcflush(fd, TCIFLUSH);
  tcsetattr(fd,TCSANOW,&newtio);


  while (1) { sleep(1); itc++;  itc&=3;
    if(itc==1 && ac<3) {    bou[0]=0;            k=0;
      if(startdome==1 || stop_dome==1){  k=1;
        if(startdome){ printf("StarD\n");
                       bou[1]='&'; startdome++; }
        if(stop_dome){ printf("StopD\n");
                       bou[1]='$'; stop_dome++; }
      } else { 
        if(ac<2)whatsend(); 
        k=strlen(bou); if(k)for(i=k;i>0;i--)bou[i]=bou[i-1];
      }
      bou[++k]=0;   bou[0]='`';
if(k>3)printf("%s\n",bou);
      write(fd,bou,k);
    }

    if (wait_flag==FALSE) {
      res = read(fd,bin,255); bin[res]=0;
      wait_flag = TRUE;      /* wait for new input */
      for(i=0;i<res;i++){
        if(bin[i]=='"')bin[i]='.';
        if(bin[i]=='\'')bin[i]=':';
        if(bin[i]==32)bin[i]='_';
        if(bin[i]=='=')bin[i]='0';
      }
printf("%s",bin);
    }
  }
}

int kk=0,jj=0;
whatsend()
{
  if((kk++&7)==0){ jj=1-jj;
    if(jj)sprintf(bou,"move 07:34:56.0 23:45:56\012");
    else  sprintf(bou,"filt i\012");
  }
}
